#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf v86d-0.1.10.tar.bz2
    cd v86d-0.1.10
    ./configure --default
    make
    strip -R .note -R .comment v86d
    mkdir -p ../v86d/sbin
    cp v86d ../v86d/sbin/
    cd ..
    rm -rf v86d-0.1.10
}

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
case "$ARCH" in
i386|amd64)
    ;;
*)
    exit 0
    ;;
esac

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
